package weaver.interfaces.akx.cronjob;

import weaver.common.DateUtil;
import weaver.conn.RecordSet;
import weaver.interfaces.schedule.BaseCronJob;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * 安科讯宿舍水电费计算计划任务
 *
 * @author:dxfeng
 * @createTime: 2024/04/10
 * @version: 1.0
 */
public class CalculateCostsJob extends BaseCronJob {
    @Override
    public void execute() {
        String currentDate = DateUtil.getCurrentDate();
        String currentMonth = currentDate.substring(0, 7);
        RecordSet rs = new RecordSet();
        try {
            rs.writeLog("当前日期：" + currentDate + ",水电费计算计划任务开始------");
            // 查询入住日期<=当前日期，且转出日期>=当前日期，或未转出的数据
            String sql = "select * from uf_rygl where rzsj <=? and (zcsj >=? or zcsj is null)";
            rs.executeQuery(sql, currentDate, currentDate);
            List<PersonnelManagement> personnelManagementList = new ArrayList<>();
            while (rs.next()) {
                PersonnelManagement personnelManagement = new PersonnelManagement();
                personnelManagement.setLd(rs.getString("ld"));
                personnelManagement.setYg(rs.getString("yg"));
                personnelManagement.setRzsj(rs.getString("rzsj"));
                personnelManagement.setZcsj(rs.getString("zcsj"));
                personnelManagementList.add(personnelManagement);
            }
            // 查询当月所有楼栋的水电费标准
            Map<String, Integer> costMap = new HashMap<>();
            sql = "select * from uf_sdfbz where yf = ?";
            rs.executeQuery(sql, currentMonth);
            while (rs.next()) {
                costMap.put(rs.getString("yf"), rs.getInt("sdfbz"));
            }

            // 计算当月的入住天数和费用
            Map<String, Map<String, List<PersonnelManagement>>> managementMap = personnelManagementList.stream().collect(Collectors.groupingBy(PersonnelManagement::getYg, Collectors.groupingBy(PersonnelManagement::getLd)));

            for (Map.Entry<String, Map<String, List<PersonnelManagement>>> entry : managementMap.entrySet()) {
                String yg = entry.getKey();
                Map<String, List<PersonnelManagement>> ldMap = entry.getValue();
                for (Map.Entry<String, List<PersonnelManagement>> item : ldMap.entrySet()) {
                    String ld = item.getKey();
                    List<PersonnelManagement> ldList = item.getValue();
                    // 计算入住的所有的天数
                    for (PersonnelManagement management : ldList) {

                    }
                    // 计算当前人员、当前楼栋的水电费
                }
            }

            rs.writeLog("当前日期：" + currentDate + ",水电费计算计划任务结束------");
        } catch (Exception e) {
            rs.writeLog("当前日期：" + currentDate + ",水电费计算计划任务异常");
            rs.writeLog(e);
        }
    }


    /**
     * 人员管理对象
     */
    private static class PersonnelManagement {
        // 楼栋
        private String ld;
        // 员工
        private String yg;
        // 入住日期
        private String rzsj;
        // 转出日期
        private String zcsj;

        public String getLd() {
            return ld;
        }

        public void setLd(String ld) {
            this.ld = ld;
        }

        public String getYg() {
            return yg;
        }

        public void setYg(String yg) {
            this.yg = yg;
        }

        public String getRzsj() {
            return rzsj;
        }

        public void setRzsj(String rzsj) {
            this.rzsj = rzsj;
        }

        public String getZcsj() {
            return zcsj;
        }

        public void setZcsj(String zcsj) {
            this.zcsj = zcsj;
        }
    }

}
